# encoding: utf-8
# frozen_string_literal: true

require 'chunky_png'

raise "Insufficient Arguments" if ARGV.size != 2

image = ChunkyPNG::Image.from_file(ARGV[0])

outfile = File.open(ARGV[1],"w")

raise "Wrong image dimensions" if image.width % 8 != 0 || image.height != 8
character_count = image.width / 8

outfile.write "DAT\n"

character_count.times do |i|
    outfile.write("' import char #{i}\n")
    8.times do |y|
        line = 0
        8.times do |x|
            line <<= 1
            line |= 1 if ChunkyPNG::Color.r(image[x+i*8,y]) == 0
        end
        outfile.write("byte %#{[line].pack('C').unpack('b8')[0]}\n")
    end
end

outfile.close


